// $Revision: 1.1 $

using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Windows.Forms;

namespace WIL
{
	/// <summary>
	/// Z֘A
	/// </summary>
	public partial class Math
	{
		/// <summary>
		/// RXgN^
		/// </summary>
		public Math()
		{
		}

		/// <summary>
		/// _W̉Z
		/// </summary>
		/// <param name="ope1">Ӓl</param>
		/// <param name="ope2">EӒl</param>
		/// <returns>
		///		ZʂԂ܂B
		/// </returns>
		public static FVIL.Data.CFviPoint Add(FVIL.Data.CFviPoint ope1, FVIL.Data.CFviPoint ope2)
		{
			ope1.X += ope2.X;
			ope1.Y += ope2.Y;
			return ope1;
		}

		/// <summary>
		/// _W̌Z
		/// </summary>
		/// <param name="ope1">Ӓl</param>
		/// <param name="ope2">EӒl</param>
		/// <returns>
		///		ZʂԂ܂B
		/// </returns>
		public static FVIL.Data.CFviPoint Sub(FVIL.Data.CFviPoint ope1, FVIL.Data.CFviPoint ope2)
		{
			ope1.X -= ope2.X;
			ope1.Y -= ope2.Y;
			return ope1;
		}

		/// <summary>
		/// Q_̒S
		/// </summary>
		/// <param name="ope1">Ӓl</param>
		/// <param name="ope2">EӒl</param>
		/// <returns>
		///		SԂ܂B
		/// </returns>
		public static FVIL.Data.CFviPoint Center(FVIL.Data.CFviPoint ope1, FVIL.Data.CFviPoint ope2)
		{
			FVIL.Data.CFviPoint center = new FVIL.Data.CFviPoint((ope1.X + ope2.X) / 2, (ope1.Y + ope2.Y) / 2);
			return center;
		}

		/// <summary>
		/// S_̒_̎Zo
		/// </summary>
		/// <param name="points">S_</param>
		/// <returns>
		///		Zoꂽ_Ԃ܂B
		/// </returns>
		public static FVIL.Data.CFviPoint Center(IList<FVIL.Data.CFviPoint> points)
		{
			List<FVIL.Data.CFviLine> lines = new List<FVIL.Data.CFviLine>();
			for (int index = 0; index < points.Count; index++)
			{
				int index2 = (index + 1) % points.Count;
				FVIL.Data.CFviLineSegment ls = new FVIL.Data.CFviLineSegment(points[index], points[index2]);
				lines.Add(ls.ToCFviLine());
			}
			FVIL.Data.CFviPoint center = FVIL.Caliper.Function.Rectangle(lines[0], lines[1], lines[2], lines[3]).Center;
			return center;
		}

		/// <summary>
		/// px̉Z
		/// </summary>
		/// <param name="ope1">Ӓl</param>
		/// <param name="ope2">EӒl</param>
		/// <returns>
		///		ZʂԂ܂B
		/// </returns>
		public static FVIL.Data.CFviAngle Add(FVIL.Data.CFviAngle ope1, FVIL.Data.CFviAngle ope2)
		{
			ope1.Degree += ope2.Degree;
			return ope1;
		}

		/// <summary>
		/// px̌Z
		/// </summary>
		/// <param name="ope1">Ӓl</param>
		/// <param name="ope2">EӒl</param>
		/// <returns>
		///		ZʂԂ܂B
		/// </returns>
		public static FVIL.Data.CFviAngle Sub(FVIL.Data.CFviAngle ope1, FVIL.Data.CFviAngle ope2)
		{
			ope1.Degree -= ope2.Degree;
			return ope1;
		}

		/// <summary>
		/// px̔]
		/// </summary>
		/// <param name="angle">px</param>
		/// <returns>
		///		]pxԂ܂B
		/// </returns>
		public static FVIL.Data.CFviAngle Invert(FVIL.Data.CFviAngle angle)
		{
			angle.Degree = -angle.Degree;
			return angle;
		}

		/// <summary>
		/// px̎Zo
		/// </summary>
		/// <param name="point">w_</param>
		/// <param name="axis">]̋@</param>
		/// <returns>
		///		ZoꂽpxԂ܂B
		/// </returns>
		public static FVIL.Data.CFviAngle Angle(FVIL.Data.CFviPoint point, FVIL.Data.CFviPoint axis)
		{
			FVIL.Data.CFviAngle angle = new FVIL.Data.CFviAngle();

			// w肳ꂽ_̍WpxZo.
			double xL = point.X - axis.X;
			double yL = point.Y - axis.Y;
			if (!(xL == 0 && yL == 0))
			{
				double R = System.Math.Atan2(yL, xL);
				angle.Radian = R;
				if (angle.Degree < 0)
					angle = new FVIL.Data.CFviAngle(360 + angle.Degree);
			}
			return angle;
		}

		/// <summary>
		/// ŏľ
		/// </summary>
		/// <param name="datas">f[^z</param>
		/// <returns>
		///		w肳ꂽf[^z̍ŏl̎wWԂ܂B
		/// </returns>
		public static int FindMin(double[] datas)
		{
			int index = 0;
			for (int i = 0; i < datas.Length; i++)
			{
				if (datas[index] > datas[i])
					index = i;
			}
			return index;
		}

		/// <summary>
		/// ŏľ
		/// </summary>
		/// <param name="datas">f[^z</param>
		/// <returns>
		///		w肳ꂽf[^z̍ŏl̎wWԂ܂B
		/// </returns>
		public static int FindMin(List<double> datas)
		{
			int index = 0;
			for (int i = 0; i < datas.Count; i++)
			{
				if (datas[index] > datas[i])
					index = i;
			}
			return index;
		}

		/// <summary>
		/// őľ
		/// </summary>
		/// <param name="datas">f[^z</param>
		/// <returns>
		///		w肳ꂽf[^z̍ől̎wWԂ܂B
		/// </returns>
		public static int FindMax(double[] datas)
		{
			int index = 0;
			for (int i = 0; i < datas.Length; i++)
			{
				if (datas[index] < datas[i])
					index = i;
			}
			return index;
		}

		/// <summary>
		/// őľ
		/// </summary>
		/// <param name="datas">f[^z</param>
		/// <returns>
		///		w肳ꂽf[^z̍ől̎wWԂ܂B
		/// </returns>
		public static int FindMax(List<double> datas)
		{
			int index = 0;
			for (int i = 0; i < datas.Count; i++)
			{
				if (datas[index] < datas[i])
					index = i;
			}
			return index;
		}
	}
}
